/* 
 * Copyright (C) 2006 Cooper Street Innovations Inc.
 *	Charles Eidsness    <charles@cooper-street.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 
 * 02110-1301, USA.
 *
 */

#ifndef DECK_H
#define DECK_H

#include "device.h"
#include "matrix.h"
#include "state.h"
#include "command.h"
#include "subckt.h"

typedef struct _includeDB includeDB_;
char * includeDBAddFile(includeDB_ *r, char *filename);

typedef struct {
	char *buffer;
	char *name;
	char *filename;
	deviceDB_ *devices;
	commandDB_ *commands;
	matrix_ *matrix;
	state_ *state;
	subcktDB_ *subckts;
	includeDB_ *includes;
} deck_;

int deckParse(deck_ *r);

#endif
