/* 
 * Copyright (C) 2006 Cooper Street Innovations Inc.
 *	Charles Eidsness    <charles@cooper-street.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 
 * 02110-1301, USA.
 *
 */

#ifndef MATRIX_H
#define MATRIX_H

#include "row.h"
#include "node.h"
#include "result.h"
#include "state.h"

typedef struct _matrix matrix_;

int matrixSolve(matrix_ *r);
int matrixReSolve(matrix_ *r);
int matrixNumRows(matrix_ *r);
int matrixNumTimesteps(matrix_ *r);

resultDB_ * matrixGetResults(matrix_ *r);

row_ * matrixFindRow(matrix_ *r, char *name, rowType_ type);
node_ * matrixFindNode(matrix_ *r, row_ *row, row_ *col);

int matrixDumpData(matrix_ *r);
int matrixWriteRaw(matrix_ *r, FILE *outFile);

int matrixRecall(matrix_ *r);
int matrixRecord(matrix_ *r, double time, int brkPoint);

int matrixInit(matrix_ *r, state_ *state);

int matrixDestroy(matrix_ **r);
matrix_ * matrixNew(matrix_ *r);


#endif
