/* 
 * Copyright (C) 2006 Cooper Street Innovations Inc.
 *	Charles Eidsness    <charles@cooper-street.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 
 * 02110-1301, USA.
 *
 */

#ifndef MATRIX_INTERNAL_H
#define MATRIX_INTERNAL_H

#include "row.h"
#include "node.h"
#include "result.h"
#include "state.h"

typedef struct _matrix matrix_;

typedef int (*matrixLibraryFunction)(matrix_ *r);
typedef struct _matrixLibrary matrixLibrary_;

struct _matrix {
	nodeDB_ *nodeDB;
	rowDB_ *rows;
	resultDB_ *results;
	
	/* Data */
	double *A;
	int *aRow;
	int *aColStart;
	double *X;
	double *B;
	int lenA;
	int lenXB;
	
	/* LU Library */
	char *name;
	matrixLibraryFunction unconfig;
	matrixLibraryFunction solve;
	matrixLibraryFunction reSolve;
	matrixLibrary_ *library;
};

int matrixInitSuperLU(matrix_ *r);

#endif
