/* 
 * Copyright (C) 2006 Cooper Street Innovations Inc.
 *	Charles Eidsness    <charles@cooper-street.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 
 * 02110-1301, USA.
 *
 */

#ifndef RESULT_H
#define RESULT_H

typedef struct _resultDB resultDB_;

int resultDBWriteRaw(resultDB_ *r, FILE *outFile);

double resultDBPrevTime(resultDB_ *r);

resultDB_ * resultDBFindTime(resultDB_ *r, double time);
resultDB_ * resultDBNextBreak(resultDB_ *r, double time, double *nextBreak);
resultDB_ * resultDBLinterp(resultDB_ *r, double time, int index, double *data);

int resultDBLength(resultDB_ *r);

int resultDBRecall(resultDB_ *r, double *data, int length);
int resultDBRecord(resultDB_ *r, double result, double *data, int length, 
		int brkPoint);

int resultDBDestroy(resultDB_ **r);
resultDB_ * resultDBNew(resultDB_ *r);

#endif
