/* 
 * Copyright (C) 2006 Cooper Street Innovations Inc.
 *	Charles Eidsness    <charles@cooper-street.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 
 * 02110-1301, USA.
 *
 */

#ifndef SUBCKT_H
#define SUBCKT_H

typedef enum {
	X_ERR = -1,
	X_VALID = 0,
	X_DONE = 1
} subcktXListStatus;

typedef struct _subcktDB subcktDB_;

char * subcktDBTransformRefDes(subcktDB_ *r, char *refdes);
char * subcktDBTransformNode(subcktDB_ *r, char *node);

subcktXListStatus subcktDBNextX(subcktDB_ *r);
char * subcktDBGetActiveBuffer(subcktDB_ *r);

int subcktDBAddXElement(subcktDB_ *r, char *name, char **nodes, int numNodes, 
		char *subcktName);
int subcktDBAddSubckt(subcktDB_ *r, char *name, char **nodes, int numNodes, 
		char *buffer);

int subcktDBDestroy(subcktDB_ **r);
subcktDB_ * subcktDBNew(subcktDB_ *r);

#endif

